/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "rptDiario.h"


void
on_btnRptDiarios_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{ 
   Gda_Recordset *grs;
   Gda_Field *field;
   gchar *FechaTransaccion = NULL;
   gchar *ComprobanteTransaccion = NULL;
   gchar *DescripcionTransaccion = NULL;
   gchar *CodigoCtaContable = NULL;
   gchar *TipoTransaccion = NULL;
   gchar *CadenaValorTransaccion = NULL;
   gfloat SaldoDebe = 0;
   gfloat SaldoHaber = 0;
   gfloat ValorTransaccion = 0;
   gfloat TotalDebeCierre  = 0;
   gfloat TotalHaberCierre = 0;
   gfloat TotalDebeEntreDosFechas  = 0;
   gfloat TotalHaberEntreDosFechas = 0;
   gfloat TotalDebeAntesFecha  = 0;
   gfloat TotalHaberAntesFecha = 0;
   gint g=0,i=0,num=0;
   gint SenalExisteAnterior = 0;
   gint CodigoCierreFechaAnterior = 0;
   gchar *TextoSaldoDebe=NULL;
   gchar *TextoSaldoHaber=NULL;
   gchar *FechaInicialReportes=NULL;
   gchar *FechaCierreUltimo=NULL;

  	grs = GDA_RECORDSET(GetListadoTotalDeTransaccionesContables ());

	gda_recordset_move_next (grs);

	if ((g=open("rptDiario.xml", O_WRONLY | O_CREAT | O_TRUNC, 0660)) != -1) {
        }

	write(g, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>",strlen("<?xml version=\"1.0\" encoding=\"UTF-8\"?>"));
	write(g, "\n<RPT_DIARIOS>",strlen("\n<RPT_DIARIOS>"));
	write(g, "\n\t<Compania>ACNE CIA. LTDA</Compania>",strlen("\n\t<Compania>ACNE CIA. LTDA</Compania>"));
	write(g, "\n\t<Periodo>1-JAN-2000 AL 31-DEC-2000</Periodo>",strlen("\n\t<Periodo>1-JAN-2000 AL 31-DEC-2000</Periodo>"));

	SaldoDebe = 0;
	SaldoHaber = 0;

	FechaInicialReportes = (gchar *)gtk_entry_get_text (GTK_ENTRY(GNOME_DATE_EDIT(GTK_OBJECT(txtFechaInicialReportes))->date_entry));
	num = ConsultarVerificarExisteCierreMenorFecha(FechaInicialReportes);  

	SenalExisteAnterior = 0;
	if (num > 0) {
		SenalExisteAnterior = 1;
		FechaCierreUltimo = (gchar *)ConsultarFechaCierreUltimo(FechaInicialReportes);
		CodigoCierreFechaAnterior = ConsultarCodigoCierreFecha(FechaCierreUltimo);
	}

	TotalDebeCierre  = 0;
	TotalHaberCierre = 0;
	TotalDebeEntreDosFechas  = 0;
	TotalHaberEntreDosFechas = 0;
	TotalDebeAntesFecha  = 0;
	TotalHaberAntesFecha = 0;

	if (SenalExisteAnterior == 1) {
		TotalDebeCierre  = ConsultarDebeCierreTotal(CodigoCierreFechaAnterior);
		TotalHaberCierre = ConsultarHaberCierreTotal(CodigoCierreFechaAnterior);

		TotalDebeEntreDosFechas  = ConsultarDebeTotalEntreDosFechas(FechaCierreUltimo, FechaInicialReportes);
		TotalHaberEntreDosFechas = ConsultarHaberTotalEntreDosFechas(FechaCierreUltimo, FechaInicialReportes);

		SaldoDebe  = TotalDebeCierre + TotalDebeEntreDosFechas;
		SaldoHaber = TotalHaberCierre + TotalHaberEntreDosFechas;
	}
	if (SenalExisteAnterior == 0) {
		TotalDebeAntesFecha   =  ConsultarDebeTotalMenorAUnaFecha(FechaInicialReportes);
		TotalHaberAntesFecha  =  ConsultarHaberTotalMenorAUnaFecha(FechaInicialReportes);

		SaldoDebe  = TotalDebeAntesFecha;
		SaldoHaber = TotalHaberAntesFecha;
	}
	
        while (gda_recordset_eof(grs)) {
		i++;
		if ((i-1)%50 == 0) {
			write(g, "\n\t<Pagina>",strlen("\n\t<Pagina>"));
			write(g, "\n\t\t<Saldo_Debe>",strlen("\n\t\t<Saldo_Debe>"));
			TextoSaldoDebe = g_strdup_printf("%f",SaldoDebe);
			write(g, TextoSaldoDebe,strlen(TextoSaldoDebe));
			write(g, "</Saldo_Debe>",strlen("</Saldo_Debe>"));

			write(g, "\n\t\t<Saldo_Haber>",strlen("\n\t\t<Saldo_Haber>"));
			TextoSaldoHaber = g_strdup_printf("%f",SaldoHaber);
			write(g, TextoSaldoHaber,strlen(TextoSaldoHaber));
			write(g, "</Saldo_Haber>",strlen("</Saldo_Haber>"));
	
		}
        
		write(g, "\n\t\t<Registro>",strlen("\n\t\t<Registro>"));

        	field = gda_recordset_field_idx (GDA_RECORDSET(grs), 8);
        	FechaTransaccion = (gchar *)gda_stringify_value(FechaTransaccion, 15, field);

		write(g, "\n\t\t\t<Fecha>",strlen("\n\t\t<Fecha>"));
		write(g, FechaTransaccion,strlen(FechaTransaccion));
		write(g, "</Fecha>",strlen("</Fecha>"));

        	field = gda_recordset_field_idx (GDA_RECORDSET(grs), 4);
        	ComprobanteTransaccion = (gchar *)gda_stringify_value(ComprobanteTransaccion, 25, field);

		write(g, "\n\t\t\t<Comprobante>",strlen("\n\t\t\t<Comprobante>"));
		write(g, ComprobanteTransaccion,strlen(ComprobanteTransaccion));
		write(g, "</Comprobante>",strlen("</Comprobante>"));

        	field = gda_recordset_field_idx (GDA_RECORDSET(grs), 3);
        	DescripcionTransaccion = (gchar *)gda_stringify_value(DescripcionTransaccion, 200, field);

		write(g, "\n\t\t\t<Descripcion>",strlen("\n\t\t\t<Descripcion>"));
		write(g, DescripcionTransaccion,strlen(DescripcionTransaccion));
		write(g, "</Descripcion>",strlen("</Descripcion>"));

        	field = gda_recordset_field_idx (GDA_RECORDSET(grs), 1);
        	CodigoCtaContable = (gchar *)gda_stringify_value(CodigoCtaContable, 20, field);

		write(g, "\n\t\t\t<Codigo>",strlen("\n\t\t\t<Codigo>"));
		write(g, CodigoCtaContable,strlen(CodigoCtaContable));
		write(g, "</Codigo>",strlen("</Codigo>"));

        	field = gda_recordset_field_idx (GDA_RECORDSET(grs), 7);
        	CadenaValorTransaccion = (gchar *)gda_stringify_value(CadenaValorTransaccion, 30, field);

		sscanf(CadenaValorTransaccion,"%f",&ValorTransaccion);

        	field = gda_recordset_field_idx (GDA_RECORDSET(grs), 6);
        	TipoTransaccion = (gchar *)gda_stringify_value(TipoTransaccion, 20, field);

		if (g_strcasecmp(TipoTransaccion,"DEBE")) {
			write(g, "\n\t\t\t<Debe>",strlen("\n\t\t\t<Debe>"));
			write(g, CadenaValorTransaccion,strlen(CadenaValorTransaccion));
			write(g, "</Debe>",strlen("</Debe>"));

			write(g, "\n\t\t\t<Haber>",strlen("\n\t\t\t<Haber>"));
			write(g, " ",strlen(" "));
			write(g, "</Haber>",strlen("</Haber>"));
			
			SaldoDebe = SaldoDebe + ValorTransaccion;
		}
		if (g_strcasecmp(TipoTransaccion,"HABER")) {
			write(g, "\n\t\t\t<Debe>",strlen("\n\t\t\t<Debe>"));
			write(g, " ",strlen(" "));
			write(g, "</Debe>",strlen("</Debe>"));

			write(g, "\n\t\t\t<Haber>",strlen("\n\t\t\t<Haber>"));
			write(g, CadenaValorTransaccion,strlen(CadenaValorTransaccion));
			write(g, "</Haber>",strlen("</Haber>"));

			SaldoHaber = SaldoHaber + ValorTransaccion;
		}

		write(g, "\n\t\t</Registro>",strlen("\n\t\t</Registro>"));

		if ((i%50 == 0)) {
			write(g, "\n\t\t<Saldo_Debe>",strlen("\n\t\t<Saldo_Debe>"));
			TextoSaldoDebe = g_strdup_printf("%f",SaldoDebe);
			write(g, TextoSaldoDebe,strlen(TextoSaldoDebe));
			write(g, "</Saldo_Debe>",strlen("</Saldo_Debe>"));

			write(g, "\n\t\t<Saldo_Haber>",strlen("\n\t\t<Saldo_Haber>"));
			TextoSaldoHaber = g_strdup_printf("%f",SaldoHaber);
			write(g, TextoSaldoHaber,strlen(TextoSaldoHaber));
			write(g, "</Saldo_Haber>",strlen("</Saldo_Haber>"));
			write(g, "\n\t</Pagina>",strlen("\n\t</Pagina>"));
	
		}

		gda_recordset_move_next (grs);

	}

	write(g, "\n\t\t<Saldo_Debe>",strlen("\n\t\t<Saldo_Debe>"));
	TextoSaldoDebe = g_strdup_printf("%f",SaldoDebe);
	write(g, TextoSaldoDebe,strlen(TextoSaldoDebe));
	write(g, "</Saldo_Debe>",strlen("</Saldo_Debe>"));

	write(g, "\n\t\t<Saldo_Haber>",strlen("\n\t\t<Saldo_Haber>"));
	TextoSaldoHaber = g_strdup_printf("%f",SaldoHaber);
	write(g, TextoSaldoHaber,strlen(TextoSaldoHaber));
	write(g, "</Saldo_Haber>",strlen("</Saldo_Haber>"));
	write(g, "\n\t</Pagina>",strlen("\n\t</Pagina>"));

	write(g, "\n</RPT_DIARIOS>\n",strlen("\n</RPT_DIARIOS>\n"));

	close(g);

}


